program Arabesque;
 uses Robot1, Robot2, Robot3, Robot4, Robot5;

 {*******************************************************}
 {*                                                     *}
 {* "Premires leons de programmation en Turbo Pascal" *}
 {* Patrick, Laurent, Radhia et Thibault COUSOT         *}
 {* ditions McGraw-Hill, Paris, 1991.                  *}
 {* Arabesque, page 147.                                *}
 {*                                                     *}
 {*******************************************************}

 { Dessin d'une arabesque. }
 
 const
  TailleGrille = 10;
  EpaisseurGrosTraits = 3;
  
 procedure Sauter(N : integer);
  { Sauter en avant de N positions sur la grille }
 begin
  lc; avf(N); bc;
 end;
 
 procedure Cercle(R : integer; ECcercle : integer);
  { Tracer un cercle de rayon R centr sur le robot avec l'paisseur }
  { de crayon ECcercle }
 begin
  lg(R * TailleGrille); ec(ECcercle);
  lc; av; pqtg; bc;
  vg; vg; vg; vg;
  lc; pqtg; av; pdt; bc;
  lg(TailleGrille); ec(EpaisseurGrosTraits);
 end;
 
 procedure QuardDetoile;
   { Quard d'une toile  huit branches circonscrite aux huit petits }
   { cercles }
 begin
   av; phtd; av; pqtg; av; phtd; av;
 end;

 procedure DemiEtoile;
   { Moiti d'une toile  huit branches circonscrite aux huit }
   { petits cercles }
 begin
   QuardDetoile; pqtg; QuardDetoile;
 end;

 procedure PetitCerclePair;
  { Cercle inscrit dans un huitime de motif en direction S, W, N, E }
 begin
  phtg; Sauter(3); Cercle(2, 1); pdt; Sauter(3); p3htg;
 end;
 
 procedure EtoilePaire;
  { Huitime de motif en direction S, W, N, E }
 begin
  phtd; av; PetitCerclePair; DemiEtoile; av; phtg; av; pdt; lc; av; 
  avf(3); pdt; bc; av;
  phtg; av; DemiEtoile; av; p3htd; avf(2);
 end;
 
 procedure PetitCercleImpair;
  { Cercle inscrit dans un huitime de motif en direction SO, NW, }
  { NE, SE }
 begin
  phtg; Sauter(2); phtg; Cercle(2, 1); phtd; pdt; Sauter(2); p3htg;
 end;
 
 procedure EtoileImpaire;
  { Huitime de motif en direction SO, NW, NE, SE }
 begin
  phtd; av; PetitCercleImpair; DemiEtoile; av; p3htd; lc; av; p3htd;
  bc; av; DemiEtoile; av; p3htd; av;
 end;
 
 procedure Motif;
  { Motif compos de 2 toiles (S, SW) ou (W, NW) ou  (N, NE) ou }
  { (E, SE) }
 begin
  EtoilePaire;
  avf(3); phtd; avf(4); pqtd;
  EtoileImpaire;
  avf(3); phtd; avf(5); pqtd;
 end;
 
 var I : integer;

begin

 lg(TailleGrille);
 eb; pn; lc; avf(2); bc;
 ec(EpaisseurGrosTraits);
 { Petit octogone et son motif intrieur }
 for I := 1 to 4 do 
  begin 
   Motif; 
  end;
 { Rejoindre le centre des cercles concentriques }
 pqtd; av; pqtg; Sauter(11);
 { Cercles concentriques }
 Cercle(3, 1);

 st;
 
end.
